=== debian/changelog ===
migraphx (7.0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1109935)

 -- Utkarsh Raj <encode.sh@protonmail.com>  Sun, 30 Nov 2025 17:54:35 +0530
